/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package echoserver02;

import java.io.IOException;
import java.io.InterruptedIOException;
import java.net.ServerSocket;
import java.net.Socket;

/**
 *
 * @author fulmanp
 */
public class Server implements Runnable {
    boolean work = true;

    public void run()
    {        
        System.out.print("Main server thread: server starting...");
        try
        {
            ServerSocket s = new ServerSocket(8189);
            s.setSoTimeout(10000);
            System.out.println(" complete");

            while(work == true && !Thread.interrupted())
            {
                try
                {
                    Socket incoming = s.accept();
                    System.out.println("New incoming connection has been accepted");
                    System.out.println("New thread is beeing created...");
                    Thread t = new Thread(new ServeClient(incoming));
                    t.start();
                }
                catch (InterruptedIOException e)
                {
                    System.out.println("10 second without any new connection...");
                }                               
            }
        }
        catch (InterruptedIOException e)
        {
            System.out.println("InterruptedIOException");
        }
        catch (IOException ex)
        {
            System.out.println("Ups... Something wrong...");
        }
        System.out.println("Main server thread: server stop");
    }

    void stopServer()
    {
        System.out.println("Main server thread: stop server signal received");
        work = false;
    }
}
