package echoserver02;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;


/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author fulmanp
 */
public class ServeClient implements Runnable {
    Socket socket;
    static int totalThreads = 0;
    int number;

    ServeClient(Socket s)
    {
        socket = s;
        totalThreads++;
        number = totalThreads;
    }

    public void run()
    {
        BufferedReader in = null;
        PrintWriter out;
        String line;

        System.out.println("I'm thread " + number);

        try
        {
            
            in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            out = new PrintWriter(socket.getOutputStream(), true);
            
            out.println("Hello! Enter BYE to exit");
            while (true) {
                line = in.readLine();
                System.out.println("Thread "+number+" read: " + line);
                if (line == null) {
                    break;
                } else {
                    out.println(line);
                    if (line.trim().equals("BYE")) {
                        break;
                    }
                }
            }
            socket.close();
        } catch (IOException ex)
        {
            System.out.println("Thread "+number+" Ups... Something wrong...");
        } finally {
            try {
                in.close();
            } catch (IOException ex) {
                System.out.println("Thread "+number+" Ups... Something wrong...");
            }
        }
    }

}
